VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 2  'vbComplexBound
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Private Type prjObject
    sName As String
    sPath As String
    sType As String
End Type

Dim prjObjects() As prjObject
Dim prjVariables() As prjObject
Dim sInput As String

Public Sub ParseProject(strFileName As String)

Dim aLines As Variant, Tell As Long, Line As Variant, Cnt&, Var

' Clean up variables
Erase prjObjects
Erase prjVariables

' Load the code
LoadCode strFileName

' Split up the lines
aLines = Split(sInput, vbNewLine)

For Tell = LBound(aLines) To UBound(aLines)

    Line = Split(aLines(Tell), "=")
    
    If UBound(Line) > 0 Then
    
        Select Case LCase(Line(0))
        Case "form", "module", "class", "usercontrol"
            
            Cnt = SafeUBound(VarPtrArray(prjObjects)) + 1
            ReDim Preserve prjObjects(Cnt)
            
            Var = Split(Line(1), ";")
            
            If UBound(Var) > 0 Then
                prjObjects(Cnt).sType = Line(0)
                prjObjects(Cnt).sName = Var(0)
                prjObjects(Cnt).sPath = GetFilePath(strFileName) & Var(1)
            Else
                prjObjects(Cnt).sPath = GetFilePath(strFileName) & Line(1)
                prjObjects(Cnt).sType = Line(0)
                prjObjects(Cnt).sName = Line(1)
            End If
            
        Case Else
        
            Cnt = SafeUBound(VarPtrArray(prjVariables)) + 1
            ReDim Preserve prjVariables(Cnt)
            
            prjVariables(Cnt).sName = Line(0)
            prjVariables(Cnt).sPath = Replace(Line(1), Chr(34), "")
            
        End Select

    End If

Next

End Sub

Public Function LoadCode(strFileName As String)

Dim Free As Long

If Dir(strFileName) = "" Then Exit Function

Free = FreeFile
sInput = Space(FileLen(strFileName))

Open strFileName For Binary As Free
    Get #1, , sInput
Close Free

End Function

Private Function GetFilePath(strFileName As String) As String

GetFilePath = Mid(strFileName, 1, InStrRev(strFileName, "\"))

End Function

Private Function FindVar(sName As String) As Long

Dim Tell As Long

For Tell = LBound(prjVariables) To UBound(prjVariables)

    If sName = prjVariables(Tell).sName Then
        FindVar = Tell
        Exit Function
    End If

Next

FindVar = -1

End Function

Public Property Get ObjectCount() As Long
ObjectCount = SafeUBound(VarPtrArray(prjObjects))
End Property

Public Property Get ObjectName(Index As Long) As String
ObjectName = prjObjects(Index).sName
End Property

Public Property Get ObjectPath(Index As Long) As String
ObjectPath = prjObjects(Index).sPath
End Property

Public Property Get ObjectType(Index As Long) As String
ObjectType = prjObjects(Index).sType
End Property

Public Property Get Variables(sName As String) As String

Dim Tell As Long

Tell = FindVar(sName)
If Tell < 0 Then Exit Property

Variables = prjVariables(Tell).sPath

End Property

Public Property Let Variables(sName As String, ByVal vNewValue As String)

Dim Tell As Long

Tell = FindVar(sName)

If Tell < 0 Then
    Tell = SafeUBound(VarPtrArray(prjVariables)) + 1
    ReDim Preserve prjVariables(Tell)

    prjVariables(Tell).sName = sName
End If

prjVariables(Tell).sPath = vNewValue

End Property

Public Property Get CodeInput() As String
CodeInput = sInput
End Property

Public Property Let CodeInput(ByVal vNewValue As String)
sInput = vNewValue
End Property
