VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 2  'vbComplexBound
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsVBParser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim sInput As String
Dim sOutput As String

Public Sub AddErrorHandler(BeginProc As String, EndProc As String)

Dim strCode As Variant, strBeginProc As String, KeyWord As Variant, lWordEnd As Long
Dim ProcName As String, ProcType As String, Paramenters As Variant, IsProcEnd As Boolean
Dim Tell As Long, Tmp As Long, lPos As Long, lWordPos As Long, IsProc As Boolean

KeyWord = Array("sub ", "function ", "friend ", "property ", Chr(34), "'")
strCode = Split(sInput, vbNewLine)

For Tell = LBound(strCode) To UBound(strCode)
    
    Tmp = InStrArray(1, strCode(Tell), KeyWord)

    If Tmp > 0 Then
        If Tmp = 1 Then
            IsProc = CBool(Mid(strCode(Tell), 1, 1) <> Chr(34) And Mid(strCode(Tell), 1, 1) <> "'")
        Else
            IsProc = CBool(Mid(strCode(Tell), Tmp, 1) <> Chr(34) And Mid(strCode(Tell), Tmp, 1) <> "'" And Mid(strCode(Tell), Tmp - 1, 1) = " ")
        
            ' If the keyword is end
            lPos = InStr(1, strCode(Tell), "end", vbTextCompare)
            
            If lPos < Tmp And lPos > 0 Then
                IsProc = False
                IsProcEnd = True
            End If
            
            ' If the keyword is exit
            lPos = InStr(1, strCode(Tell), "exit", vbTextCompare)
            
            If lPos < Tmp And lPos > 0 Then
                IsProc = False
                IsProcEnd = False
            End If
            
            ' If the function is declared, jump over the error-handler appender
            lPos = InStr(1, strCode(Tell), "declare", vbTextCompare)
            
            If lPos < Tmp And lPos > 0 Then
                IsProc = False
                IsProcEnd = False
            End If
        End If
    
        If IsProc Then
            lPos = InStr(Tmp, strCode(Tell), " ") + 1
            lWordPos = InStr(lPos, strCode(Tell), "(")
            lWordEnd = InStr(lWordPos, strCode(Tell), ")")
            
            ProcType = Mid(strCode(Tell), Tmp, lPos - Tmp)
            ProcName = Mid(strCode(Tell), lPos, lWordPos - lPos)
            
            If lWordEnd - lWordPos - 1 > 0 Then
                Paramenters = Split(Mid(strCode(Tell), lWordPos + 1, lWordEnd - lWordPos - 1), ",", , vbTextCompare)
            Else
                Paramenters = ""
            End If
            
            If IsArray(Paramenters) Then
                Paramenters = Replace(Join(RemoveInArray(Paramenters, "as "), ", "), "optional ", "", , , vbTextCompare)
                Paramenters = Replace(Paramenters, "paramarray ", "", , , vbTextCompare)
                Paramenters = Replace(Paramenters, "byval ", "", , , vbTextCompare)
                Paramenters = Replace(Paramenters, "byref ", "", , , vbTextCompare)
            End If
            
            strBeginProc = Replace(Mid(BeginProc, 1, Len(BeginProc) - 2), "[ProcName]", ProcName, , , vbTextCompare)
            strBeginProc = Replace(strBeginProc, "[ProcType]", ProcType, , , vbTextCompare)
            strBeginProc = Replace(strBeginProc, "[Paramenters]", Paramenters, , , vbTextCompare)
            strCode(Tell) = strCode(Tell) & vbNewLine & vbNewLine & strBeginProc
            
            IsProc = False
        End If
        
        If IsProcEnd And Len(EndProc) > 0 Then
            strBeginProc = Replace(EndProc, "[ProcName]", ProcName, , , vbTextCompare)
            strBeginProc = Replace(strBeginProc, "[ProcType]", ProcType, , , vbTextCompare)
            strBeginProc = Replace(strBeginProc, "[Paramenters]", Paramenters, , , vbTextCompare)
            strCode(Tell) = strBeginProc & vbNewLine & strCode(Tell)
            
            IsProcEnd = False
        End If
    End If

Next

sOutput = Join(strCode, vbNewLine)

End Sub

Public Function RemoveInArray(lpArray, strFind As String, Optional Compare As VbCompareMethod = vbTextCompare)

Dim Tell As Long, Tmp As Long

For Tell = LBound(lpArray) To UBound(lpArray)

    Tmp = InStr(1, lpArray(Tell), strFind, vbTextCompare)

    If Tmp > 0 Then
        lpArray(Tell) = Trim$(Mid(lpArray(Tell), 1, Tmp - 1))
    Else
        lpArray(Tell) = Trim$(lpArray(Tell))
    End If

Next

RemoveInArray = lpArray

End Function

Public Function InStrArray(Start As Long, strCompare, lpArray, Optional Compare As VbCompareMethod = vbTextCompare) As Long

Dim Tell As Long, lSmallest As Long, lTmp&

If Start < 1 Then
    Start = 1
End If

lSmallest = Len(strCompare) + 1

For Tell = LBound(lpArray) To UBound(lpArray)
    lTmp = InStr(Start, strCompare, lpArray(Tell), Compare)

    If lTmp < lSmallest And lTmp > 0 Then
        lSmallest = lTmp
    End If
Next

If lSmallest > Len(strCompare) Then
    lSmallest = 0
End If

InStrArray = lSmallest

End Function

Public Function LoadCode(strFileName As String)

Dim Free As Long

If Dir(strFileName) = "" Then Exit Function

Free = FreeFile
sInput = Space(FileLen(strFileName))

Open strFileName For Binary As Free
    Get #1, , sInput
Close Free

End Function

Public Function SaveCode(strFileName As String)

Dim Free As Long

Free = FreeFile

Open strFileName For Output As Free
    Print sOutput
Close Free

End Function

Public Property Get CodeOutput() As String
CodeOutput = sOutput
End Property

Public Property Get CodeInput() As String
CodeInput = sInput
End Property

Public Property Let CodeInput(ByVal vNewValue As String)
sInput = vNewValue
End Property
