Attribute VB_Name = "modGlobal"
Option Explicit

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function SafeUBound(ByVal lpArray As Long, Optional Dimension As Long = 1) As Long

On Error Resume Next
Dim lAddress&, cElements&, lLbound&, cDims%

If Dimension < 1 Then
    SafeUBound = -1
    Exit Function
End If

CopyMemory lAddress, ByVal lpArray, 4

If lAddress = 0 Then
    ' The array isn't initilized
    SafeUBound = -1
    Exit Function
End If

' Calculate the dimenstions
CopyMemory cDims, ByVal lAddress, 2
Dimension = cDims - Dimension + 1

' Obtain the needed data
CopyMemory cElements, ByVal (lAddress + 16 + ((Dimension - 1) * 8)), 4
CopyMemory lLbound, ByVal (lAddress + 20 + ((Dimension - 1) * 8)), 4

SafeUBound = cElements + lLbound - 1

End Function

Public Function SafeLBound(ByVal lpArray As Long, Optional Dimension As Long = 1) As Long

On Error Resume Next
Dim lAddress&, cElements&, lLbound&, cDims%

If Dimension < 1 Then
    SafeLBound = -1
    Exit Function
End If

CopyMemory lAddress, ByVal lpArray, 4

If lAddress = 0 Then
    ' The array isn't initilized
    SafeLBound = -1
    Exit Function
End If

' Calculate the dimenstions
CopyMemory cDims, ByVal lAddress, 2
Dimension = cDims - Dimension + 1

' Obtain the needed data
CopyMemory lLbound, ByVal (lAddress + 20 + ((Dimension - 1) * 8)), 4

SafeLBound = lLbound

End Function

Sub Main()

frmMain.Show

End Sub
